module top(clk,rst,x0_in,x1_in,x2_in,x3_in,xavg_out,xdiff_out);

input clk,rst;
input x0_in,x1_in,x2_in,x3_in;
output xavg_out,xdiff_out;

wire [7:0] x0_in,x1_in,x2_in,x3_in;

reg [7:0] xavg_out, xdiff_out;
reg [9:0] xsum_next; //= 0;
reg [7:0] xavg_next; // = 0;
//wire xsum_next, xavg_next;

always @(posedge clk) begin: update
  if (rst) begin
     xavg_out <= 0;
     xdiff_out <= 0;
  end else begin: normal
     xsum_next = x0_in + x1_in + x2_in + x3_in;
     xavg_next = xsum_next >> 2;
     xavg_out <= xavg_next;
     xdiff_out <= (xavg_next >= x3_in)?(xavg_next - x3_in):(x3_in - xavg_next);
     end
end 

endmodule
