void next_timeframe();
void set_inputs();
extern const unsigned int bound;

//Global structure to monitor Verilog signals from C
struct module_top {
unsigned int ser_in;
unsigned int state;
unsigned int xavg_out,xdiff_out,xsum_in;
_Bool rst;
_Bool done;
};

extern const struct module_top top;

unsigned int exp_xavg(unsigned int x0, unsigned int x1,
	                  unsigned int x2, unsigned int x3) {
	unsigned int result;
	result = (x0+x1+x2+x3)>>2;
	return result; }


int main() {
unsigned int cycle;
unsigned int sx0, sx1, sx2, sx3;

 	// Assign arbitrary values to C inputs
	sx0 = nondet_uint(); sx1 = nondet_uint();
	sx2 = nondet_uint(); sx3 = nondet_uint();

	__CPROVER_assume(top.done==1); // All other verog signals have arbitrary values

	//Unwind verilog model for 4 cycles with reset de-asserted
	top.rst = 0;
	top.ser_in = sx0; //drive sx0 into serin
	set_inputs();	
	next_timeframe(); 

	top.rst = 0; //Deassert input rst
	top.ser_in = sx1; //drive sx1 into serin
	set_inputs();
	next_timeframe(); 

	top.rst = 0; //Deassert input rst
	top.ser_in = sx2; //drive sx2 into serin
	set_inputs();
	next_timeframe(); 

	top.rst = 0; //Deassert input rst
	top.ser_in = sx3; //drive sx2 into serin
	set_inputs();
	next_timeframe(); 
	
	//check outputs @ cycle=i+4
	unsigned int texp_xavg = exp_xavg(sx0, sx1, sx2, sx3);
	unsigned int exp_diff = (texp_xavg >= sx3)?(texp_xavg - sx3):(sx3 - texp_xavg);

	__CPROVER_assert(top.done==1, "Back to done high");

	__CPROVER_assert( (top.xavg_out == texp_xavg) &&
		(top.xdiff_out == exp_diff), "Compare outputs with C reference values");



//Base Case: Check done is high upon reset
//time-frame=0
 top.rst = 1;
 set_inputs();
 next_timeframe(); //reset outputs
//time-frame=1; State = 1'b00
	__CPROVER_assert(top.done==1, "Done asserted on reset");


}

