unsigned __CPROVER_bitvector[8] nondet_bv8();

void next_timeframe();
void set_inputs();
extern const unsigned int bound;

//Global structure to monitor Verilog signals from C
struct module_top {
unsigned __CPROVER_bitvector[8] ser_in;
unsigned __CPROVER_bitvector[8] state;
unsigned __CPROVER_bitvector[8] xavg_out,xdiff_out;
_Bool rst;
_Bool done;
};

extern const struct module_top top;

unsigned int exp_xavg(unsigned int x0, unsigned int x1,
	                  unsigned int x2, unsigned int x3) {
	unsigned int result;
	result = (x0+x1+x2+x3)>>2;
	return result; }


int main() {
unsigned int cycle;
unsigned int sx0 = 0, sx1 = 0, sx2 = 0, sx3 = 0;
unsigned int temp = exp_xavg(sx0,sx1,sx2,sx3);
assert( temp== 0);

 //time-frame=0
 top.rst = 1;
 set_inputs();
 next_timeframe(); //reset outputs
//time-frame=1; State = 1'b00

 assert(top.state == 0);
 
//bound should be (multiples of 4) + 1
for(cycle=0; cycle<(bound-1)/4; cycle++) {
    //You are in state = 1'b00
	__CPROVER_assert(top.state==0, "At State 0");
	__CPROVER_assert(top.done==1, "Done asserted on reset");

	//check outputs whenever done is high (@ cycle=i+4)
	unsigned int texp_xavg = exp_xavg(sx0, sx1, sx2, sx3);
	unsigned int exp_diff = (texp_xavg >= sx3)?(texp_xavg - sx3):(sx3 - texp_xavg);
	__CPROVER_assert( (top.xavg_out == texp_xavg) &
		(top.xdiff_out == exp_diff), "Compare outputs with C reference values");

	//Choose arbitrary inputs
	sx0 = nondet_bv8(); sx1 = nondet_bv8();
	sx2 = nondet_bv8(); sx3 = nondet_bv8();

	top.rst = 0;
	top.ser_in = sx0; //drive sx0 into serin
	set_inputs();	
	next_timeframe(); 

	top.rst = 0; //Deassert input rst
	top.ser_in = sx1; //drive sx1 into serin
	set_inputs();
	next_timeframe(); 

	top.rst = 0; //Deassert input rst
	top.ser_in = sx2; //drive sx2 into serin
	set_inputs();
	next_timeframe(); 

	top.rst = 0; //Deassert input rst
	top.ser_in = sx3; //drive sx2 into serin
	set_inputs();
	next_timeframe(); 
	
	//assert(0);
	//check outputs @ cycle=i+4
	//__CPROVER_assert( (top.xavg_out == texp_xavg) &
	//	(top.xdiff_out == exp_diff), "Compare outputs with C reference values");

};
}

